//-----------------------------------------------------------------------------
// lottomachine.h
//
// Specification for the lotto machine
//
// Midterm
// Robert Mudge
// 10/10/1999
//
//-----------------------------------------------------------------------------

#ifndef LOTTOMACHINE_H
#define LOTTOMACHINE_H

#ifdef STDVECTOR
  #include <vector>
#endif

#include "ball.h"

namespace MIDTERM
{

  class LottoMachine
  {

    public:

      //-----------------------------------------------------------------------
      LottoMachine(int number_of_ball = 0);

      //-----------------------------------------------------------------------
      ~LottoMachine();

      //-----------------------------------------------------------------------
      void show(void) const;

      //-----------------------------------------------------------------------
      const Ball& pick(void);

      //-----------------------------------------------------------------------
      void reset(void);

      //-----------------------------------------------------------------------
      int get_balls_picked(void) const;

    private:
       
      // Example using either a dynmically sized array of type std::vector
      // or using a normal array of ball objects
      #ifdef STDVECTOR
        std::vector<Ball> machine;
      #else
        enum MachineSize{ NUMBER_OF_BALLS = 49 };
        Ball machine[NUMBER_OF_BALLS];
      #endif

      int number_of_balls;  // number of balls in the machine

      int balls_picked;  // keep track of the number of balls picked.

  };

}
#endif

// eof - lottomachine.h
